#!/usr/bin/perl

# psites_gather

open (PSITES, "psites.list") or die "cannot open psites.list\n";
open (INFO_REAL, ">psites_real.txt") or die "cannot open psites_real.txt\n";
open (INFO_BACK, ">psites_back.txt") or die "cannot open psites_back.txt\n";

$onechain	= "yes";

$npatchR	= 0;
$npatchB	= 0;
@psites		= <PSITES>;
foreach $site (@psites)	{
    if (substr($site,0,1) ne "#") {
	chomp $site;
	@words = split (" ",$site);
	if ($onechain eq 'yes') {
		$pdbfile	= substr($words[0],0,4);	# chars 1-4 are pdb id
		$chain		= substr($words[0],4,1);	# char 5 is chain id
	} else {
		$pdbfile	= $words[0];
	}
	print "processing $words[0]\n";
	$res	= $words[1];
	$nres	= $words[2];

	$file	= $words[0].'.sa';
	open (ASA, "$file") or die "cannot open $file\n";
	@asa	= <ASA>;

	$nasa			= 0;
	foreach $line (@asa)	{
		chomp $line;
		@tmp = split (" ",$line);
		if ($tmp[0] eq ">") {
			$nasa++;
			if ($tmp[3] eq "TYRH") {			# swap TYRH to TYR
			  $tmp[3] = "TYR";
			}
			$all_id	= $pdbfile.$tmp[1].$tmp[2].$tmp[3];	# pdb.chain.nres.res
#print "all_id = $all_id  nasa = $nasa\n";
			$asa_id[$nasa]		= $all_id;
			$asa_tot[$nasa]		= $tmp[4];
			$asa_plr[$nasa]		= $tmp[5];
			$asa_npr[$nasa]		= $tmp[6];
#print "residue $all_id asas $tmp[4] $tmp[5] $tmp[6]\n";
		}
	}
	close (ASA);

	$file	= $words[0].'_potl.hist';		# this time around just get xyz's
	open (HIST, "$file") or die "cannot open $file\n";
	@hist	= <HIST>;

# CHECK THAT WE FILL IN ALL xyz values for $NASA slots here
	foreach $line (@hist)	{
		chomp $line;
		@tmp = split (" ",$line);
		if (($tmp[0] eq "ATOM") and ($tmp[1] eq "CA")) {
			if ($tmp[2] eq "TYRH") {
			  $tmp[2]	= "TYR";
			}
			$all_id	= $pdbfile.$tmp[3].$tmp[4].$tmp[2];	# pdb.chain.nres.res
			for ($iasa=1; $iasa<=$nasa; $iasa++) {
				if ($all_id eq $asa_id[$iasa]) {
					$x_res[$iasa]	= $tmp[5];
					$y_res[$iasa]	= $tmp[6];
					$z_res[$iasa]	= $tmp[7];
				}
			}
		}
	}
	close (HIST);

	$file	= $words[0].'_potl.hist';
	open (HIST, "$file") or die "cannot open $file\n";
	@hist	= <HIST>;

# fix POTL to 'POS' here: +ve surrounds for Plation is what we test
	$ENV{POTL}	= 'POS';

	foreach $line (@hist)	{
		chomp $line;
		@tmp = split (" ",$line);
		if ($tmp[0] eq "ATOM") {
#			substr($line,20,1) = " ";
			$a	= substr($line,16,13);
			if      ($ENV{POTL} eq 'POS') {
#				$b	= substr($line,56,40);
				$b	= substr($line,57,42);
			} elsif ($ENV{POTL} eq 'ABS') {
#				$b	= substr($line,102,40);
				$b	= substr($line,103,42);
			} else {
				print "set POTL env variable to POS or ABS\n";
				exit;
			}
#print "a = $a\n";
#print "b = $b\n\n";
			@bits 	= split (" ",$line);
			if ($bits[2] eq "TYRH") {
			  $bits[2] = "TYR";
			}
			$resh	= $bits[2];
			$atyp	= $bits[1];
			$nresh	= $bits[4];
			$chainh	= $bits[3];
			$all_id = $pdbfile.$chainh.$nresh.$resh;	# pdb.chain.nres.res
			$any_site	= "NO";
			$real_site	= "NULL";
			if (($resh eq "SER") and ($atyp eq "OG")) {
				$any_site		= "YES";
				if (($resh eq $res) and ($nresh eq $nres) and ($chainh eq $chain)) {
					print INFO_REAL "$pdbfile $a $b\n";
					$real_site	= "YES"
				} else {
					print INFO_BACK "$pdbfile $a $b\n";
					$real_site	= "NO";
				}
			}
			if (($resh eq "THR") and ($atyp eq "OG1")) {
				$any_site		= "YES";
				if (($resh eq $res) and ($nresh eq $nres) and ($chainh eq $chain)) {
					print INFO_REAL "$pdbfile $a $b\n";
					$real_site	= "YES";
				} else {
					print INFO_BACK "$pdbfile $a $b\n";
					$real_site	= "NO";
				}
			}
			if (($resh eq "TYR") and ($atyp eq "OH")) {
				$any_site		= "YES";
				if (($resh eq $res) and ($nresh eq $nres) and ($chainh eq $chain)) {
					print INFO_REAL "$pdbfile $a $b\n";
					$real_site	= "YES";
				} else {
					print INFO_BACK "$pdbfile $a $b\n";
					$real_site	= "NO";
				}
			}

			if ($any_site eq "YES") {
			  $sum_plr		= 0.;
			  $sum_npr		= 0.;
			  $num_patch		= 0;
			  $res_found		= "NO";
			  for ($iiasa=1; $iiasa<=$nasa; $iiasa++) {
#print "all_id = $all_id asa_id = $asa_id[$iiasa]\n";
			    if ($all_id eq $asa_id[$iiasa]) {
			      $xi		= $x_res[$iiasa];
			      $yi		= $y_res[$iiasa];
			      $zi		= $z_res[$iiasa];
			      $res_found	= "YES";
			      $iasa		= $iiasa;
			    }
			  }
			  if ($res_found eq "NO") {
			    print "RES NOT FOUND for all_id = $all_id \n";
			      for ($iiasa=1; $iiasa<=$nasa; $iiasa++) {
				print " unfound all_id = $all_id asa_id = $asa_id[$iiasa]\n";
			      }
#			    exit;
			  } else {
			  if ($asa_tot[$iasa] > 5.) {
			    for ($jasa=1; $jasa<=$nasa; $jasa++) {
			      if ($asa_tot[$jasa] > 5.) {
			        $xj		= $x_res[$jasa];
			        $yj		= $y_res[$jasa];
			        $zj		= $z_res[$jasa];
			        $dist		= sqrt (($xi-$xj)**2 + ($yi-$yj)**2 + ($zi-$zj)**2);
			        if ($dist < 10.) {
				  $num_patch++;
				  $sum_plr	= $sum_plr + $asa_plr[$jasa];
				  $sum_npr	= $sum_npr + $asa_npr[$jasa];

#print "sums inc $dist $iasa $jasa $asa_plr[$jasa] $asa_npr[$jasa]\n";
#print "$xi $yi $zi $xj $yj $zj\n";

				}
			      }
			    }
			  }
			  if ($num_patch != 0) {
			    $perc_npr		= 100.*$sum_npr/($sum_plr+$sum_npr);
			    print "$perc_npr $num_patch $real_site $all_id\n";
			    if       ($real_site eq "YES") {
			      $npatchR++;
			      $patchR[$npatchR]	= $perc_npr;
			    } elsif ($real_site eq "NO") {
			      $npatchB++;
			      $patchB[$npatchB]	= $perc_npr;
			    }
			  }
			 }
			}
		}
	}
	close (HIST);
    }
}
close (PSITES);
close (INFO_REAL);
close (INFO_BACK);

# now process into histograms: first the percentage patch non-polarity

print "npatchR,B = $npatchR $npatchB\n";
for ($s=1; $s<=100; $s++) {
	$valhistP[$s]	= 0.5 + 1*($s - 1);
	$hpR[$s]	= 0;
	$hpB[$s]	= 0;
}
for ($ip=1; $ip<=$npatchR; $ip++) {
	$s		= 1 + int($patchR[$ip]);
	$hpR[$s]++;
}
for ($ip=1; $ip<=$npatchB; $ip++) {
	$s		= 1 + int($patchB[$ip]);
	$hpB[$s]++;
}

open (PATCH_HISTS, ">npr_perc.hist") or die "cannot open npr_perc.hist\n";
$totR			= 0;
$totB			= 0;
for ($s=1; $s<=100; $s++) {
	$freqR		= (100/$npatchR) * $hpR[$s];
	$freqB		= (100/$npatchB) * $hpB[$s];
	$totR		+= $freqR;
	$totB		+= $freqB;
	printf PATCH_HISTS "%6.1f %5.1f %5.1f\n", $valhistP[$s], $freqR, $freqB;
}
printf PATCH_HISTS "\n Real / Back sums = $totR $totB\n";
close (PATCH_HISTS);

open (INFO_REAL, "psites_real.txt") or die "cannot open psites_real.txt\n";
@real	= <INFO_REAL>;
$nr	= 0;
foreach $line (@real)	{
	chomp $line;
	@words = split (" ",$line);
	$nr++;
	for ($i=1; $i<=6; $i++) {
		$rel[$i][$nr]	= $words[$i+4];
	}
}
close (INFO_REAL);

open (INFO_BACK, "psites_back.txt") or die "cannot open psites_back.txt\n";
@back	= <INFO_BACK>;
$nb	= 0;
foreach $line (@back)	{
	chomp $line;
	@words = split (" ",$line);
	$nb++;
	for ($i=1; $i<=6; $i++) {
		$bck[$i][$nb]	= $words[$i+4];
	}
}
close (INFO_BACK);

for ($s=1; $s<=20; $s++) {
	$valhist[$s]		= -195 + 10*($s - 1);
	for ($i=1; $i<=6; $i++) {
		$hr[$i][$s]	= 0;
		$cr[$i][$s]	= 0;
		$hb[$i][$s]	= 0;
		$cb[$i][$s]	= 0;
	}
}

for ($ir=1; $ir<=$nr; $ir++) {
	for ($i=1; $i<=6; $i++) {
		$val		= -$rel[$i][$ir];	# SWAP SIGN AROUND TO MATCH OTHER WORK
		if ($val >=  199) {$val =  199;}
		if ($val <= -199) {$val = -199;}
		$s		= 1 + int(($val + 199)/10);
		$hr[$i][$s]++;
	}
}

for ($ib=1; $ib<=$nb; $ib++) {
	for ($i=1; $i<=6; $i++) {
		$val		= -$bck[$i][$ib];	# SWAP SIGN AROUND TO MATCH OTHER WORK
		if ($val >=  199) {$val =  199;}
		if ($val <= -199) {$val = -199;}
		$s		= 1 + int(($val + 199)/10);
		$hb[$i][$s]++;
	}
}

$rperc				= 100/$nr;
$bperc				= 100/$nb;
for ($i=1; $i<=6; $i++) {
	for ($s=1; $s<=20; $s++) {
		$hr[$i][$s]	= $hr[$i][$s]*$rperc;
		$hb[$i][$s]	= $hb[$i][$s]*$bperc;
		if ($s == 1) {
			$cr[$i][$s]	= $hr[$i][$s];
			$cb[$i][$s]	= $hb[$i][$s];
		} else {
			$cr[$i][$s]	= $hr[$i][$s] + $cr[$i][$s-1];
			$cb[$i][$s]	= $hb[$i][$s] + $cb[$i][$s-1];
		}
	}
}

open (RHISTS, ">psites_real.hist") or die "cannot open psites_real.hist\n";
for ($s=1; $s<=20; $s++) {
	printf RHISTS "%6.1f %5.1f %5.1f %5.1f %5.1f %5.1f %5.1f\n", $valhist[$s], $hr[1][$s], $hr[2][$s], $hr[3][$s], $hr[4][$s], $hr[5][$s], $hr[6][$s];
}
print RHISTS "\n";
print RHISTS " Now the cumulative distributions\n";
print RHISTS "\n";
for ($s=1; $s<=20; $s++) {
	printf RHISTS "%6.1f %5.1f %5.1f %5.1f %5.1f %5.1f %5.1f\n", $valhist[$s], $cr[1][$s], $cr[2][$s], $cr[3][$s], $cr[4][$s], $cr[5][$s], $cr[6][$s];
}
close (RHISTS);

open (BHISTS, ">psites_back.hist") or die "cannot open psites_back.hist\n";
for ($s=1; $s<=20; $s++) {
	printf BHISTS "%6.1f %5.1f %5.1f %5.1f %5.1f %5.1f %5.1f\n", $valhist[$s], $hb[1][$s], $hb[2][$s], $hb[3][$s], $hb[4][$s], $hb[5][$s], $hb[6][$s];
}
print BHISTS "\n";
print BHISTS " Now the cumulative distributions\n";
print BHISTS "\n";
for ($s=1; $s<=20; $s++) {
	printf BHISTS "%6.1f %5.1f %5.1f %5.1f %5.1f %5.1f %5.1f\n", $valhist[$s], $cb[1][$s], $cb[2][$s], $cb[3][$s], $cb[4][$s], $cb[5][$s], $cb[6][$s];
}
close (BHISTS);

system ("rm -f npr_perc.hist");

exit;

